https://github.com/lark-parser/lark/issues/1480
https://github.com/lark-parser/lark/pull/1483

From 4809ce89ca005b71f6db930c4aabf6496a502795 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Tom=C3=A1=C5=A1=20Hrn=C4=8Diar?= <thrnciar@redhat.com>
Date: Wed, 6 Nov 2024 16:47:11 +0100
Subject: [PATCH] Wrap functools.partial in staticmethod() to add compatibility
 with Python 3.14

Fixes: #1480
---
 tests/test_trees.py | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

diff --git a/tests/test_trees.py b/tests/test_trees.py
index 1f69869e..07687ac0 100644
--- a/tests/test_trees.py
+++ b/tests/test_trees.py
@@ -254,7 +254,7 @@ def ab_method(self, a, b):
             ab_partialmethod = partialmethod(ab_for_partialmethod, 1)
             set_union = set(["a"]).union
             static_add = staticmethod(add)
-            partial_reduce_mul = partial(reduce, mul)
+            partial_reduce_mul = staticmethod(partial(reduce, mul))
 
             custom_callable = CustomCallable()
 
@@ -355,8 +355,8 @@ def test(prefix, s, postfix):
 
         @v_args(inline=True)
         class T(Transformer):
-            a = functools.partial(test, "@", postfix="!")
-            b = functools.partial(lambda s: s + "!")
+            a = staticmethod(functools.partial(test, "@", postfix="!"))
+            b = staticmethod(functools.partial(lambda s: s + "!"))
 
         res = T().transform(tree)
         assert res.children == ["@TEST1!", "test2!"]
